Name:    xgboost
Version: 2.0.2
Release: 1
Summary: Extreme gradient boosting
License: Apache-2.0
URL:     https://github.com/dmlc/xgboost

Source0: https://github.com/dmlc/xgboost/releases/xgboost-%{version}.tar.gz
Source1: https://github.com/dmlc/dmlc-core/tags/dmlc-core-0.5.tar.gz

BuildRequires: cmake doxygen gcc gcc-c++ python3-setuptools
BuildRequires: gtest-devel python3-devel
Requires: %{name}-libs = %{version}-%{release}

%description
XGBoost is an optimized distributed gradient boosting library designed
to be highly efficient, flexible and portable.  It implements machine
learning algorithms under the Gradient Boosting framework.  XGBoost
provides parallel tree boosting (also known as GBDT, GBM) that solve
many data science problems in a fast and accurate way.

%package libs
Summary: Run-time libraries for %{name}

%description libs
This package contains run-time libraries for %{name}.

%package devel
Summary: Development files for %{name}
Requires: %{name}-libs = %{version}-%{release}

%description devel
This package contains development files for %{name}.

%package -n python3-%{name}
Summary: Python files for %{name}
Requires: python3-numpy python3-scipy
Requires: %{name}-libs = %{version}-%{release}

%description -n python3-%{name}
This package contains python files for %{name}.

%prep
%autosetup -n %{name}-%{version}
tar xzf %{SOURCE1} --directory dmlc-core --strip-components=1

%build
%cmake -DBUILD_SHARED_LIBS=no .
%cmake_build

pushd python-package
echo "import setuptools; setuptools.setup(packages=['xgboost'])" > setup.py
%{__python3} setup.py build
popd

%install
%cmake_install 
# do not install any static libraries
rm -rf %{buildroot}/usr/lib*/libdmlc.a

pushd python-package
%{__python3} setup.py install --root %{buildroot} --install-lib=%{python3_sitearch}
echo %{version} > %{buildroot}%{python3_sitearch}/%{name}/VERSION
popd

%check
%ctest

%files
%license LICENSE
%doc README.md
%doc CONTRIBUTORS.md
%{_bindir}/*

%files libs
%{_libdir}/lib*.so*

%files devel
%{_includedir}/*
%{_libdir}/cmake/*
%{_libdir}/pkgconfig/*

%files -n python3-%{name}
%{python3_sitearch}/*

%changelog
* Wed Nov 29 2023 Nathan Scott <nathans@redhat.com> - 2.0.2-1
- Initial version for Fedora.
